//' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
//' This software DKFS-51 is a disk operating system
//' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
//' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
//' and Keil C51 compiler but can be also used for other 8 and 16-bit
//' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
//' and hardware code (like timers and serial port inicialization).
//' In the current state this is a COMMERCIAL software.
//' Please contact with author by e-mail d_korabelnikov@mail.ru
//' if you want to use this code in your devices or applications.
//' Next text is Russian Win-1251
//' DKFS-51 (C)   2005-2008.
//' DKFS-51      8  16-
//'    I2C/SPI/SD-Card FLASH .
//' DKFS-51     MCS-51  
//'  Keil C51    
//'   8  16-  (AVR,ATMEGA)  
//'   ,     
//' (      ).
//'      .    
//'  e-mail d_korabelnikov@mail.ru
//'           .
// fat8   ,  BAD_SECTOR=254
#define demomaxsector  253
#define demosectorsize 256
#define ichip2         0xA0
//    (  ,    - )
#define F_RETRYCNT     50

//  2   ,   LOG2(256)=8
#define demosectorshift  8
#define demodisksize  (demomaxsector*(demosectorsize+2))

bit flash_timeout;data unsigned char flash_retry;

bit iwrite(unsigned char *memory,unsigned int addr,unsigned int nbytes)
{data unsigned int cnt;bit first;
flash_timeout=0;
flash_retry=F_RETRYCNT;
//    I2C (  SDA    1)
do {if (flash_retry==0) {flash_timeout=1;return 1;}} while (cl_stop()==0);
//  24C512 (    0     )
flash_retry=F_RETRYCNT; // timeout = 100 timer interrupts (100 milliseconds) 
do {cl_stop();cl_start();if (flash_retry==0) {flash_timeout=1;return 1;}} while (wrdata(ichip2));

//  
wraddr(addr);first=1;
for (cnt=0;cnt<nbytes;cnt++)
{if (first==0) {if ((addr & 0x7F)==0) {
//    128 ,      
//   24C512    (   =128)
//     5 
//    (  24C512  128   )

flash_retry=F_RETRYCNT;do {cl_stop();cl_start();if (flash_retry==0) {flash_timeout=1;return 1;}} while (wrdata(ichip2));

wraddr(addr);
}} else first=0;
//      1 ( )   1 ()
if (wrdata(*memory++)) return 1;addr++;
}
// ,  0 ()
cl_stop();return 0;
}

bit iread(unsigned char *memory,unsigned int addr,unsigned int nbytes)
{flash_timeout=0;
flash_retry=F_RETRYCNT;
//    I2C (  SDA    1)
do {if (flash_retry==0) {flash_timeout=1;return 1;}} while (cl_stop()==0);
//  24C512 (    0     )
flash_retry=F_RETRYCNT; // timeout = 100 timer interrupts (100 milliseconds) 
do {cl_stop();cl_start();if (flash_retry==0) {flash_timeout=1;return 1;}} while (wrdata(ichip2));
//  
wraddr(addr);
//   (  =1)
cl_start();wrdata(ichip2+1);
// asmcode.a51
//   ,   24C512   
rdata2(memory,nbytes);
// ,  0 ()
cl_stop();
return 0;
}
