;' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
;' This software DKFS-51 is a disk operating system
;' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
;' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
;' and Keil C51 compiler but can be also used for other 8 and 16-bit
;' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
;' and hardware code (like timers and serial port inicialization).
;' In the current state this is a COMMERCIAL software.
;' Please contact with author by e-mail d_korabelnikov@mail.ru
;' if you want to use this code in your devices or applications.
;' Next text is Russian Win-1251
;' DKFS-51 (C)   2005-2008.
;' DKFS-51      8  16-
;'    I2C/SPI/SD-Card FLASH .
;' DKFS-51     MCS-51  
;'  Keil C51    
;'   8  16-  (AVR,ATMEGA)  
;'   ,     
;' (      ).
;'      .    
;'  e-mail d_korabelnikov@mail.ru
;'           .
;  Purpose:
;	Calculate CRC-16 Values.  Uses The CCITT-16 Polynomial, Expressed As
;	X^16 + X^12 + X^5 + 1

; C declaration
; bit crc16bad(uns char *dataptr,uns int datalen)
; unsigned int crc16x(uns char *dataptr,uns int datalen)

; R2 -> dataptrHi, R1 -> dataptrLo,R4 -> datalenHi, R5 -> datalenLo
; R3 -> DataptrMemType (1),
; :    datalen,  
;  CRC16Hi,CRC16Lo.
; : crc16bad 1   , 0  .
; crc16x -  CRC ( " " :)   R6, R7)
 
public 	_crc16x
public 	_crc16bad
D_CRC16_HI	equ 6	; R6
D_CRC16_LO	equ 7	; R7
_crc16bad:
_crc16x:	mov D_CRC16_HI,#0
		mov D_CRC16_LO,#0
		mov DPH,R2
		mov DPL,R1
crcnext:	mov a,R5
		orl a,R4
		jz crccompare
		movx a,@DPTR
		inc DPTR

		xrl	a,D_CRC16_HI	; XOR High Of CRC With Character
		mov     b,a		
		call getcrc16hi		; Get High Of Table Entry
		xrl	a,D_CRC16_LO	; XOR With Low
		mov	D_CRC16_HI,a	; Store To High
		mov     a,b
		call getcrc16lo		; Get Low Of Table Entry
		mov	D_CRC16_LO,a	; Store To Low Of CRC

if 0
		xrl	D_CRC16_HI,a	; HI ^= Data
		mov B,#8
crcp1:		clr	c		; 0 Into Low Bit
		mov	a,D_CRC16_LO	; D_CRC << 1
		rlc	a		; Shift Left
		mov	D_CRC16_LO,a	; Store Back
		mov	a,D_CRC16_HI	; Get High Byte
		rlc	a		; Shift Left
		mov	D_CRC16_HI,a	; Store Back
		jnc	crcp2		; Skip If Bit 15 Wasn't Set
		xrl	D_CRC16_HI,#10h	; XOR In Polynomial High
		xrl	D_CRC16_LO,#21h	; XOR In Polynomial Low
crcp2:		djnz	b,crcp1
endif


		dec R5
		cjne R5,#0FFh,crc001
		dec R4
crc001:		jmp crcnext
crccompare:	movx a,@DPTR
		inc DPTR
		cjne a,D_CRC16_HI,crcbad
		movx a,@DPTR
		cjne a,D_CRC16_LO,crcbad		
		clr C
		ret
crcbad:		setb C
		ret

$include (crc16tab.a51)
