//' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
//' This software DKFS-51 is a disk operating system
//' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
//' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
//' and Keil C51 compiler but can be also used for other 8 and 16-bit
//' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
//' and hardware code (like timers and serial port inicialization).
//' In the current state this is a COMMERCIAL software.
//' Please contact with author by e-mail d_korabelnikov@mail.ru
//' if you want to use this code in your devices or applications.
//' Next text is Russian Win-1251
//' DKFS-51 (C)   2005-2008.
//' DKFS-51      8  16-
//'    I2C/SPI/SD-Card FLASH .
//' DKFS-51     MCS-51  
//'  Keil C51    
//'   8  16-  (AVR,ATMEGA)  
//'   ,     
//' (      ).
//'      .    
//'  e-mail d_korabelnikov@mail.ru
//'           .
#pragma ot(size)
#define uns unsigned
#define and &&
#define or  ||
#pragma nointpromote
#pragma large
#include <intel/reg51f.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "asmcode.h"
#include "i2cdemo.c"
#include "unixtime.c"
//      FAT8
#define USEFAT8
#include "filesys.h"
#include "filesys.c"

#define SPEEDCHECK

//     
//  ,  -     ( 60000 )
//  ,   -    ( 500 )
//    (1000   1   )     
#define Timer0Reload 4000

//    
// serialint()    
bit ready;

char putchar (char c)  
{
if (c==10) {SBUF=13;while (TI==0);TI = 0;}
 SBUF=c;while (TI==0);TI = 0;
 return c;
}

#ifdef SPEEDCHECK
bit testspeed=0;data uns int t0intcount;
#endif


data uns int timerdelay;

bit textinputemulate,textinputemulate2;data char emubyte;data int emuspeed;
char *emuptr;
char emutext[]=\
"Hello\r"
"Hello\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b again\r"
"test0\r"
"test1\r"
"test2\r"
"test3\r"
"test4\r"
"test5\r"
"See you !\r";

void emulate_input()
{if (textinputemulate==0) return;
 if (ready) return;
if (textinputemulate2==0) {emuptr=emutext;textinputemulate2=1;}
if (*emuptr==0) emuptr=emutext;
emubyte=*emuptr++;RI=1;
}

void timer0() interrupt 1
{TR0=0;
 TH0=(-Timer0Reload)>>8;
 TL0=(-Timer0Reload) & 0xFF;
 TR0=1;
if (timerdelay) timerdelay--;
#ifdef SPEEDCHECK
if  (testspeed) t0intcount++;
#endif
if (textinputemulate!=0)  {emuspeed=(emuspeed+1) & 255;if (emuspeed==0) emulate_input();}
}

#ifdef SPEEDCHECK
#define teststart() {testspeed=0;t0intcount=0;testspeed=1;}
#define testprint() {testspeed=0;printf("Ticks=%lu\n",Timer0Reload * (uns long)t0intcount);}
#else
#define teststart()
#define testprint()
#endif

void delay(uns int millisec)
{timerdelay=millisec;
while (timerdelay) /*wait*/;
}

//    
xdata uns char prnbuf[128];
//   ( ,  )
uns char rxbuf[122];
//   ( ,  )
uns char txbuf[256];
//rxlen -    
// txp1,txp2 -     
//  txbuf - 256 -       ( )
data uns char rxlen,txp1,txp2;


/*      Hyperterminal    

 :
void inputrs()
{txp1=txp2=0;rxlen=0;ready=0;while (ready==0) {while (txp1!=txp2) putchar(txbuf[txp2++]);}}
     ,        

*/

void serialint() interrupt 4
{
if (RI)
  {RI=0;B=SBUF;if (textinputemulate2) B=emubyte; if (ready==0) {
   if (B==13) {if (rxlen<=120) rxbuf[rxlen]=0;ready=1;}
   else if ((rxlen>0) && (B==8)) {rxlen--;txbuf[txp1++]=8;txbuf[txp1++]=32;txbuf[txp1++]=8;}
   else if ((rxlen<120) && (B>31)) {txbuf[txp1++]=rxbuf[rxlen++]=B;}}}
}

void inputrs()
{txp1=txp2=0;rxlen=0;ready=0;while (ready==0) {while (txp1!=txp2) putchar(txbuf[txp2++]);}
putchar('\n');
}

void starttimer0()
{TMOD|=0x01; //  0  1 - 16- 
TH0=(-Timer0Reload)>>8;
TL0=(-Timer0Reload) & 0xFF;
TR0=1;
ET0=1; //         timer0()
EA=1;
}

//    
//   11.059 MHz 
//   SMOD  TH1    
void comspeed(uns int spd)
{
PCON |= 0x80; //SMOD=1
SCON  = 0x50;		/* SCON: mode 1, 8-bit UART, enable rcvr      */
TMOD |= 0x20;           /* TMOD: timer 1, mode 2, 8-bit reload        */
if      (spd== 1200) TH1=-48;
else if (spd== 2400) TH1=-24;
else if (spd== 4800) TH1=-12;
else if (spd== 9600) TH1= -6;
else if (spd==19200) TH1= -3; 
else if (spd==57600) TH1= -1;
else                 TH1= -3; // default 19200
TR1   = 1; /* TR1:  timer 1 run       */
ES=1;      /* Enable serial interrupt         serialint()*/
EA=1;
}

// ,      cmd.c
void test0_crcplay();
void test1_sector_ops();
void test2_format_test();
void test3_hello_dkdos();
void test4_look_inside();
void test5_append_file();

#include "cmd.c"

/*   ,    
  */

void test0_crcplay()
{int i;
printf("---Test 0---\n");
printf(" =0");
memset(diskbuf,0,sectorsize);
printf("crc=%04X\n",crc16x(diskbuf,sectorsize));
printf(" =1");
memset(diskbuf,0xFF,sectorsize);
printf("crc=%04X\n",crc16x(diskbuf,sectorsize));
printf("    0  1");
for (i=0;i<7;i++)
{memset(diskbuf,0,sectorsize);diskbuf[i*32]=1;
printf("crc=%04X\n",crc16x(diskbuf,sectorsize));}
delay(3000);}

void test1_sector_ops()
{printf("---Test 1---\n");
printf("    0xFF\n" );
memset(demodisk,0xFF,demodisksize);
printf("  1:\n");
printf("secread returns %02bd\n",secread(diskbuf,1));
delay(3000);
printf("   1:\n");
secformat(diskbuf,1);
printf("crc=%04X ",crc16x(diskbuf,sectorsize));
printf("   1   0()\n");
printf("secread returns %02bd\n",secread(diskbuf,1));
delay(10000);
}

void test2_format_test()
{printf("---Test 2---\n");
printf("  \n");
diskformat('A');
f_setdrive('A');
delay(10000);
}


void test3_hello_dkdos()
{xdata long i;
printf("---Test 3---\n");
f_setdrive('A');
printf(" \n");
f_create("file1",1000L);
f_create("file2",2000L);
f_create("file3",4000L);
dircmd();
delay(10000);
printf("  -  myfile1.txt\n");
if (f_open("file1")) {sprintf(prnbuf,"Testing...\n");f_write(prnbuf,strlen(prnbuf));
							sprintf(prnbuf,"Testing2..\n");f_write(prnbuf,strlen(prnbuf));							
							sprintf(prnbuf,"Testing3..\n");f_write(prnbuf,strlen(prnbuf));
							sprintf(prnbuf,"Testing4..\n");f_write(prnbuf,strlen(prnbuf));
							f_close();}

dircmd();
delay(10000);
printf(" myfile1.txt \n");
prnbuf[1]=0;
if (f_open("file1")) {while (f_read(prnbuf,1)==0) printf("%s",prnbuf);f_close();
							}
printf("\n-----\n");
delay(10000);
printf("    myfile3.txt  LONG i  0  999\n");
printf("(: I  4 )\n");
if (f_open("file3")) {for (i=0;i<=999;i++) f_write((uns char*)&i,4);f_close();}
printf("  myfile3.txt  0,999,571\n");
if (f_open("file3")) {f_seek(4*  0L);f_read((uns char*)&i,4);printf("%ld\n",i);
							f_seek(4*999L);f_read((uns char*)&i,4);printf("%ld\n",i);
							f_seek(4*571L);f_read((uns char*)&i,4);printf("%ld\n",i);
							f_close();}
printf("\n-----\n");
dircmd();
delay(10000);
}

void test4_look_inside()
{xdata long i;
printf("---Test 4---\n");
printf(" dir(1 )\n");
secdump(1);
delay(20000);
printf(" fat(  )\n");
secdump(1+dirsectorsize);
delay(20000);
printf(",   dir  fat,    myfile2.txt\n");
f_delete("file2");
printf(" dir(1 )\n");
secdump(1);
delay(20000);
printf(" fat(  )\n");
secdump(1+dirsectorsize);
delay(20000);
dircmd();
delay(20000);
printf("  myfile4.txt .  9000 \n");
f_create("file4",9000L);
dircmd();
delay(20000);
printf(" dir(1 )\n");
secdump(1);
delay(20000);
printf(" fat(  )\n");
secdump(1+dirsectorsize);
printf(" ,    fat  myfile4.txt  \n");
delay(20000);
printf("    \n");
printf("    myfile4.txt  LONG i  0  2249\n");
printf("(: I  4 )\n");
teststart();
if (f_open("file4")) {for (i=0;i<=2249;i++) f_write((uns char*)&i,4);f_close();}
testprint();
printf("  myfile4.txt  0,2249,1380\n");
if (f_open("file4")) {f_seek(4*   0L);f_read((uns char*)&i,4);printf("%ld\n",i);
							f_seek(4*2249L);f_read((uns char*)&i,4);printf("%ld\n",i);
							f_seek(4*1380L);f_read((uns char*)&i,4);printf("%ld\n",i);
							f_close();}
delay(20000);
}

void test5_append_file()
{printf("---Test 5---\n");
dircmd();
delay(10000);
printf(" myfile1.txt  \n");
if (f_open("file1")) {f_writemod=MOD_WRITE; // ,     
							//   f_seek   F_EOF    
							// (       )
							f_seek(wdir.size); //     
							sprintf(prnbuf," \n");f_write(prnbuf,strlen(prnbuf));
							f_close();}
dircmd();
delay(10000);
printf(" myfile1.txt \n");
prnbuf[1]=0;
if (f_open("file1")) {while (f_read(prnbuf,1)==0) printf("%s",prnbuf);f_close();
							}
printf("\n-----\n");
delay(10000);}


void main()
{
starttimer0();
comspeed(19200);
/*
btime(timebuf,usec(8,12,26,18,28,30));
printf("%bu %bu %bu %02bu:%02bu:%02bu\n",\
timebuf[5],timebuf[4],timebuf[3],timebuf[2],timebuf[1],timebuf[0]);
delay(10000);
*/

textinputemulate=1;
cmd();

}

