//' DKFS-51 (C) Dmitriy Korabelnikov 2005-2008.
//' This software DKFS-51 is a disk operating system
//' for 8-bit and 16-bit microcontrollers based on I2C/SPI/SD-Card FLASH memory.
//' DKFS-51 is intended promarily for MCS-51 family of microcontrollers
//' and Keil C51 compiler but can be also used for other 8 and 16-bit
//' microcontrollers (like AVR, ATMEGA) assuming rewritten asm, interrupt
//' and hardware code (like timers and serial port inicialization).
//' In the current state this is a COMMERCIAL software.
//' Please contact with author by e-mail d_korabelnikov@mail.ru
//' if you want to use this code in your devices or applications.
//' Next text is Russian Win-1251
//' DKFS-51 (C)   2005-2008.
//' DKFS-51      8  16-
//'    I2C/SPI/SD-Card FLASH .
//' DKFS-51     MCS-51  
//'  Keil C51    
//'   8  16-  (AVR,ATMEGA)  
//'   ,     
//' (      ).
//'      .    
//'  e-mail d_korabelnikov@mail.ru
//'           .
#pragma ot(size)
#define uns unsigned
#define and &&
#define or  ||
#pragma nointpromote
#pragma large
#include <intel/reg51f.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "asmcode.h"
#include "i2cdemo.c"
#include "unixtime.c"
#include "filesys.h"
#include "filesys.c"

#define SPEEDCHECK

//     
//  ,  -     ( 60000 )
//  ,   -    ( 500 )
//    (1000   1   )     
#define Timer0Reload 4500

//    
// serialint()    
bit ready;

char putchar (char c)  
{
if (c==10) {SBUF=13;while (TI==0);TI = 0;}
 SBUF=c;while (TI==0);TI = 0;
 return c;
}

#ifdef SPEEDCHECK
bit testspeed=0;data uns int t0intcount;
#endif


data uns int timerdelay;

bit textinputemulate,textinputemulate2;data char emubyte;data int emuspeed;
char *emuptr;
char emutext[]=\
"Hello\r"
"Hello\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b again\r"
"X( 8) :) \b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\bhelp\r"
"a:\r"
"fmt\r"
"create file1 1000\r"
"create file2 2000\r"
"create file3 3000\r"
"test1\r"
//"type memo\r"
"type mrus\r"
"==================================================================================\r"
"dump 1\r"
"dump 2\r"
"dump 3\r"
"dir\r"
"del file2\r"
"dir\r"
"dump 2\r"
"b:\r"
"fmt\r"
"create notes 1000\r"
"create for   2478\r"
"create all   5000\r"
"dir\r"
"See you !\r";

void emulate_input()
{if (textinputemulate==0) return;
 if (ready) return;
if (textinputemulate2==0) {emuptr=emutext;textinputemulate2=1;}
if (*emuptr==0) emuptr=emutext;
emubyte=*emuptr++;RI=1;
}

void timer0() interrupt 1
{TR0=0;
 TH0=(-Timer0Reload)>>8;
 TL0=(-Timer0Reload) & 0xFF;
 TR0=1;
if (timerdelay) timerdelay--;
#ifdef SPEEDCHECK
if  (testspeed) t0intcount++;
#endif
if (textinputemulate!=0)  {emuspeed=(emuspeed+1) & 255;if (emuspeed==0) emulate_input();}
}

#ifdef SPEEDCHECK
#define teststart() {testspeed=0;t0intcount=0;testspeed=1;}
#define testprint() {testspeed=0;printf("Ticks=%lu\n",Timer0Reload * (uns long)t0intcount);}
#else
#define teststart()
#define testprint()
#endif

void delay(uns int millisec)
{timerdelay=millisec;
while (timerdelay) /*wait*/;
}

//    
xdata uns char prnbuf[128];
//   ( ,  )
uns char rxbuf[122];
//   ( ,  )
uns char txbuf[256];
//rxlen -    
// txp1,txp2 -     
//  txbuf - 256 -       ( )
data uns char rxlen,txp1,txp2;


/*      Hyperterminal    

 :
void inputrs()
{txp1=txp2=0;rxlen=0;ready=0;while (ready==0) {while (txp1!=txp2) putchar(txbuf[txp2++]);}}
     ,        

*/

void serialint() interrupt 4
{
if (RI)
  {RI=0;B=SBUF;if (textinputemulate2) B=emubyte; if (ready==0) {
   if (B==13) {if (rxlen<=120) rxbuf[rxlen]=0;ready=1;}
   else if ((rxlen>0) && (B==8)) {rxlen--;txbuf[txp1++]=8;txbuf[txp1++]=32;txbuf[txp1++]=8;}
   else if ((rxlen<120) && (B>31)) {txbuf[txp1++]=rxbuf[rxlen++]=B;}}}
}

void inputrs()
{txp1=txp2=0;rxlen=0;ready=0;while (ready==0) {while (txp1!=txp2) putchar(txbuf[txp2++]);}
putchar('\n');
}

void starttimer0()
{TMOD|=0x01; //  0  1 - 16- 
TH0=(-Timer0Reload)>>8;
TL0=(-Timer0Reload) & 0xFF;
TR0=1;
ET0=1; //         timer0()
EA=1;
}

//    
//   11.059 MHz 
//   SMOD  TH1    
void comspeed(uns int spd)
{
PCON |= 0x80; //SMOD=1
SCON  = 0x50;		/* SCON: mode 1, 8-bit UART, enable rcvr      */
TMOD |= 0x20;           /* TMOD: timer 1, mode 2, 8-bit reload        */
if      (spd== 1200) TH1=-48;
else if (spd== 2400) TH1=-24;
else if (spd== 4800) TH1=-12;
else if (spd== 9600) TH1= -6;
else if (spd==19200) TH1= -3; 
else if (spd==57600) TH1= -1;
else                 TH1= -3; // default 19200
TR1   = 1; /* TR1:  timer 1 run       */
ES=1;      /* Enable serial interrupt         serialint()*/
EA=1;
}

void test1cmd()
{char *text,*file;
file="memo";
if (f_exists(file)) f_delete(file);
text=\
"This is a text\n"
"This is second line of  text\n";
f_create(file,strlen(text));
if (f_open(file)) {f_write(text,strlen(text));f_close();}
file="mrus";
if (f_exists(file)) f_delete(file);
text=\
"(C) Copyright Dmitriy Korabelnikov 2005-2008\n"
"DKFS-51\n"
"   8051- \n"
"  8,16 -  \n"
"\n"
"      FLASH Atmel 24,25,45\n"
"    Keil C   \n"
":\n"
"      (f_open,f_read,f_write,f_seek  )\n"
"   c     HyperTerminal\n"
"      \n"
"     \n"
"    CRC16,   \n"
"     FLASH     2-4 \n"
"        \n"
"    4  -   8051\n"
" :\n"
":       8051 \n"
"        (AVR, ATMEGA)\n"
"   +     :\n"
"ROM 8-10 (   Keil C)\n"
"XRAM 500  - 8     \n"
"RS-232      \n"
"\n"
"    - 40 ,  \n"
"    \n";

f_create(file,strlen(text));
if (f_open(file)) {f_write(text,strlen(text));f_close();}
}



#include "cmd.c"

void main()
{
starttimer0();
comspeed(19200);
/*
btime(timebuf,usec(8,12,26,18,28,30));
printf("%bu %bu %bu %02bu:%02bu:%02bu\n",\
timebuf[5],timebuf[4],timebuf[3],timebuf[2],timebuf[1],timebuf[0]);
delay(10000);
*/
delay(1);
textinputemulate=1;
cmd();
}

