'freebasic
' (C) Dmitriy Korabernikov 2008
' This program is absolutely free for distribution
' Purpose:
' Fast and easy search of uneffective and possibly wrong codes in MSC-51 binary files
' (C)  
'           
' :
'             8051 .
#include "windows.bi"
deflng a-z
dim cop(255),cnt(255)
dim mnem$(255),cmdlen(255),cmdtime(255)
dim hcall(&hFFFF) as ushort
dim htopsub(7) as ushort,subaddr(7) as ushort
dim buf as ubyte
dim top3 as single
dim str1 as zstring*256
dim str2 as zstring*256

restore table51
for i=0 to 255
cop(i)=i
read unused$,mnem$(i),cmdlen(i),cmdtime(i)
next



'screen 12
cmd$=command$
if cmd$="" then goto help
open cmd$ for binary as #1
filelen=lof(1)
if filelen=0 or filelen > 2^18 then end
print cmd$
get #1,1,buf
if buf<>2 then print "Warning: possibly not 8051 binary code"
seek #1,1
maxpc=filelen-1:if maxpc>&hffff then maxpc=&hffff:print "Warning:only first 64KB are testing"
pc=0
acallcnt=0
while pc<=maxpc
get #1,,buf:pc=pc+1:cnt(buf)=cnt(buf)+1
cod=buf
' LCALL
if cod=&h12 then
  get #1,,buf:hi=buf:get #1,,buf:lo=buf:pc=pc+2:addr=hi*256+lo
  hcall(addr)=hcall(addr)+1
' ACALL
elseif (cod and &h1F)=&h11 then
  acallcnt=acallcnt+1
  hi=cod shr 5:get #1,,buf:lo=buf:pc=pc+1:page=pc and &hF800:addr=page+256*hi+lo
  hcall(addr)=hcall(addr)+1
' other commands
else
  for i=1 to cmdlen(cod)-1:get #1,,buf:pc=pc+1:next i
end if
wend
close
gosub sort
top3=0
print "Total size of code:";maxpc+1
print "16 most popular codes:"
print "cop memonic            cmdlen found  size % of total"
for i=0 to 15
cod=cop(i)
opcode$=right$("0"+hex$(cod),2)
mnemon$=left$(mnem$(cod)+space$(24),24)
siz=cmdlen(cod)*cnt(i)
print opcode$;space$(2);mnemon$;:print using "# ##### ##### ##.##%";cmdlen(cod);cnt(i);siz;100.0*siz/filelen
if i<=2 then top3=top3+100.0*siz/filelen
next i
print using "first 3 opcodes: ##.##%";top3
print "ACALL found       ";acallcnt
c=0
for i=0 to &hffff
    if hcall(i)>0 then c=c+1
next i
print "Subroutines found:";c
'  8      
margin=32768:st=32768
do
k=0
for i=0 to 7:htopsub(i)=0:subaddr(i)=i:next i
for i=0 to &hFFFF
    if hcall(i)>margin then
        if k<8 then htopsub(k)=hcall(i):subaddr(k)=i
        k=k+1
    end if
next i
st=st/2
if k<8 then margin=margin-st
if k>8 then margin=margin+st
if k=8 then exit do
loop while st>1
print "most popular calls are:"
for i=0 to k-1
print using "##### times";htopsub(i);:print  " to address ";right$("0000"+hex$(subaddr(i)),4)
next j
'sleep
end

'      
sort:
ex=0
while ex=0
ex=-1
for i=0 to 254
    if cnt(i)<cnt(i+1) then
        ex=0:swap cnt(i),cnt(i+1):swap cop(i),cop(i+1)
    end if
next i
wend
return

help:
restore helptxt:read str1
do:CharToOem str1,str2:print str2:read str1:loop while str1<>"*"
print "--- press any key to end ---"
q$=input$(1)
end

helptxt:
data "Usage:"
data "stat51 filename.bin > output.txt"
data "(C) Dmitriy Korabelnikov 2008"
data "simple CALL-MOV test for 51 binary code"
data "stat51 founds most often used bytes (opcodes) in binary code"
data "for Intel MSC-51 compatible microcontrollers"
data ""
data "Results are not (but!) very correct because there is no real disassembling,"
data "just simple byte scanning and counting"
data ""
data "Next text is Russian DOS-866"
data ":"
data "stat51 filename.bin > output.txt"
data "(C)   2008"
data " CALL-MOV   MSC-51  "
data "stat51      ()   "
data " Intel MSC-51  "
data ""
data "  ( !) ,     ,"
data "    "
data "*"

table51:
data "00","NOP (or byte 00h)",1,1 
data "01","AJMP addr",2,2	
data "02","LJMP addr",3,2	
data "03","RR A",1,1	
data "04","INC A",1,1	
data "05","INC direct",2,1	
data "06","INC @R0",1,1	
data "07","INC @R1",1,1	
data "08","INC R0",1,1	
data "09","INC R1",1,1	
data "0A","INC R2",1,1	
data "0B","INC R3",1,1	
data "0C","INC R4",1,1	
data "0D","INC R5",1,1	
data "0E","INC R6",1,1	
data "0F","INC R7",1,1	
data "10","JBC bit,addr",3,2	
data "11","ACALL addr",2,2	
data "12","LCALL addr",3,2	
data "13","RRC A",1,1	
data "14","DEC A",1,1	
data "15","DEC direct",2,1	
data "16","DEC @R0",1,1	
data "17","DEC @R1",1,1	
data "18","DEC R0",1,1	
data "19","DEC R1",1,1	
data "1A","DEC R2",1,1	
data "1B","DEC R3",1,1	
data "1C","DEC R4",1,1	
data "1D","DEC R5",1,1	
data "1E","DEC R6",1,1	
data "1F","DEC R7",1,1	
data "20","JB bit,addr",3,2	
data "21","AJMP addr",2,2	
data "22","RET",1,2	
data "23","RL A",1,1	
data "24","ADD A,#data",2,1	
data "25","ADD A,direct",2,1	
data "26","ADD A,@R0",1,1	
data "27","ADD A,@R1",1,1	
data "28","ADD A,R0",1,1	
data "29","ADD A,R1",1,1	
data "2A","ADD A,R2",1,1	
data "2B","ADD A,R3",1,1	
data "2C","ADD A,R4",1,1	
data "2D","ADD A,R5",1,1	
data "2E","ADD A,R6",1,1	
data "2F","ADD A,R7",1,1	
data "30","JNB bit,addr",3,2	
data "31","ACALL addr",2,2
data "32","RETI",1,2
data "33","RLC A",1,1
data "34","ADDC A,#data",2,1
data "35","ADDC A,direct",2,1
data "36","ADDC A,@R0",1,1
data "37","ADDC A,@R1",1,1
data "38","ADDC A,R0",1,1
data "39","ADDC A,R1",1,1
data "3A","ADDC A,R2",1,1
data "3B","ADDC A,R3",1,1
data "3C","ADDC A,R4",1,1
data "3D","ADDC A,R5",1,1
data "3E","ADDC A,R6",1,1
data "3F","ADDC A,R7",1,1
data "40","JC addr",2,2
data "41","AJMP addr",2,2
data "42","ORL direct,A",2,1
data "43","ORL direct,#data",3,2
data "44","ORL A,#data",2,1
data "45","ORL A,direct",2,1
data "46","ORL A,@R0",1,1
data "47","ORL A,@R1",1,1
data "48","ORL A,R0",1,1
data "49","ORL A,R1",1,1
data "4A","ORL A,R2",1,1
data "4B","ORL A,R3",1,1
data "4C","ORL A,R4",1,1
data "4D","ORL,A,R5",1,1
data "4E","ORL A,R6",1,1
data "4F","ORL A,R7",1,1
data "50","JNC addr",2,2
data "51","ACALL addr",2,2
data "52","ANL direct,A",2,1
data "53","ANL direct,#data",3,2
data "54","ANL A,#data",2,1
data "55","ANL A,direct",2,1
data "56","ANL A,@R0",1,1
data "57","ANL A,@R1",1,1
data "58","ANL A,R0",1,1
data "59","ANL A,R1",1,1
data "5A","ANL A,R2",1,1
data "5B","ANL A,R3",1,1
data "5C","ANL A,R4",1,1
data "5D","ANL A,R5",1,1
data "5E","ANL A,R6",1,1
data "5F","ANL A,R7",1,1
data "60","JZ addr",2,2
data "61","AJMP addr",2,2
data "62","XRL direct,A",2,1
data "63","XRL direct,#data",3,2
data "64","XRL A,#data",2,1
data "65","XRL A,direct",2,1
data "66","XRL A,@R0",1,1
data "67","XRL A,@R1",1,1
data "68","XRL A,R0",1,1
data "69","XRL A,R1",1,1
data "6A","XRL A,R2",1,1
data "6B","XRL A,R3",1,1
data "6C","XRL A,R4",1,1
data "6D","XRL A,R5",1,1
data "6E","XRL A,R6",1,1
data "6F","XRL A,R7",1,1
data "70","JNZ addr",2,2
data "71","ACALL addr",2,2
data "72","ORL C,bit",2,2
data "73","JMP @A+DPTR",1,2
data "74","MOV A,#data",2,1
data "75","MOV direct,#data",3,2
data "76","MOV @R0,#data",2,1
data "77","MOV @R1,#data",2,1
data "78","MOV R0,#data",2,1
data "79","MOV R1,#data",2,1
data "7A","MOV R2,#data",2,1
data "7B","MOV R3,#data",2,1
data "7C","MOV R4,#data",2,1
data "7D","MOV R5,#data",2,1
data "7E","MOV R6,#data",2,1
data "7F","MOV R7,#data",2,1
data "80","SJMP addr",2,2
data "81","AJMP addr",2,2
data "82","ANL C,bit",2,2
data "83","MOVC A,@A+PC",1,2
data "84","DIV AB",1,4
data "85","MOV direct,direct",3,2
data "86","MOV direct,@R0",2,2
data "87","MOV direct,@R1",2,2
data "88","MOV direct,R0",2,2
data "89","MOV direct,R1",2,2
data "8A","MOV direct,R2",2,2
data "8B","MOV direct,R3",2,2
data "8C","MOV direct,R4",2,2
data "8D","MOV direct,R5",2,2
data "8E","MOV direct,R6",2,2
data "8F","MOV direct,R7",2,2
data "90","MOV DPTR,#data",3,2
data "91","ACALL addr",2,2
data "92","MOV bit,",2,2
data "93","MOVC A,@A+DPTR",1,2
data "94","SUBB A,#data",2,1
data "95","SUBB A,direct",2,1
data "96","SUBB A,@R0",1,1
data "97","SUBB A,@R1",1,1
data "98","SUBB A,R0",1,1
data "99","SUBB A,R1",1,1
data "9A","SUBB A,R2",1,1
data "9B","SUBB A,R3",1,1
data "9C","SUBB A,R4",1,1
data "9D","SUBB A,R5",1,1
data "9E","SUBB A,R6",1,1
data "9F","SUBB A,R7",1,1
data "A0","ORL C,/bit",2,2
data "A1","AJMP addr",2,2
data "A2","MOV C,bit",2,1
data "A3","INC DPTR",1,2
data "A4","MUL AB",1,4
data "A5","byte 0A5h",1,1
data "A6","MOV @R0,direct",2,2
data "A7","MOV @R1,direct",2,2
data "A8","MOV R0,direct",2,2
data "A9","MOV R1,direct",2,2
data "AA","MOV R2,direct",2,2
data "AB","MOV R3,direct",2,2
data "AC","MOV R4,direct",2,2
data "AD","MOV R5,direct",2,2
data "AE","MOV R6,direct",2,2
data "AF","MOV R7,direct",2,2
data "B0","ANL C,/bit",2,2
data "B1","ACALL addr",2,2
data "B2","CPL bit",2,1
data "B3","CPL ",1,1
data "B4","CJNE A,#data,addr",3,2
data "B5","CJNE A,direct,addr",3,2
data "B6","CJNE @R0,#data,addr",3,2
data "B7","CJNE @R1,#data,addr",3,2
data "B8","CJNE R0,#data,addr",3,2
data "B9","CJNE R1,#data,addr",3,2
data "BA","CJNE R2,#data,addr",3,2
data "BB","CJNE R3,#dara,addr",3,2
data "BC","CJNE R4,#data,addr",3,2
data "BD","CJNE R5,#data,addr",3,2
data "BE","CJNE R6,#data,addr",3,2
data "BF","CJNE R7,#data,addr",3,2
data "C0","PUSH direct",2,2
data "C1","AJMP addr",2,2
data "C2","CLR bit",2,1
data "C3","CLR ",1,1
data "C4","SWAP A",1,1
data "C5","XCH A,direct",2,1
data "C6","XCH A,@R0",1,1
data "C7","XCH A,@R1",1,1
data "C8","XCH A,R0",1,1
data "C9","XCH A,R1",1,1
data "CA","XCH A,R2",1,1
data "CB","XCH A,R3",1,1
data "CC","XCH A,R4",1,1
data "CD","XCH A,R5",1,1
data "CE","XCH A,R6",1,1
data "CF","XCH A,R7",1,1
data "D0","POP direct",2,2
data "D1","ACALL addr",2,2
data "D2","SETB bit",2,1
data "D3","SETB ",1,1
data "D4","DA A",1,1
data "D5","DJNZ direct,addr",3,2
data "D6","XCHD A,@R0",1,1
data "D7","XCHD A,@R1",1,1
data "D8","DJNZ R0,addr",2,2
data "D9","DJNZ R1,addr",2,2
data "DA","DJNZ R2,addr",2,2
data "DB","DJNZ RS,addr",2,2
data "DC","DJNZ R4,addr",2,2
data "DD","DJNZ RS,addr",2,2
data "DE","DJNZ R6,addr",2,2
data "DF","DJNZ R7,addr",2,2
data "E0","MOVX A,@DPTR",1,2
data "E1","AJMP addr",2,2
data "E2","MOVX A,@R0",1,2
data "E3","MOVX A,@R1",1,2
data "E4","CLR A",1,1
data "E5","MOV A,direct",2,1
data "E6","MOV A,@R0",1,1
data "E7","MOV A,@R1",1,1
data "E8","MOV A,R0",1,1
data "E9","MOV A,R1",1,1
data "EA","MOV A,R2",1,1
data "EB","MOV A,R3",1,1
data "EC","MOV A,R4",1,1
data "ED","MOV A,R5",1,1
data "EE","MOV A,R6",1,1
data "EF","MOV A,R7",1,1
data "F0","MOVX @DPTR,A",1,2
data "F1","ACALL addr",2,2
data "F2","MOVX @R0,A",1,2
data "F3","MOVX @R1,A",1,2
data "F4","CPL A",1,1
data "F5","MOV direct,A",2,1
data "F6","MOV @R0,A",1,1
data "F7","MOV @R1,A",1,1
data "F8","MOV R0,A",1,1
data "F9","MOV R1,A",1,1
data "FA","MOV R2,A",1,1
data "FB","MOV R3,A",1,1
data "FC","MOV R4,A",1,1
data "FD","MOV R5,A",1,1
data "FE","MOV R6,A",1,1
data "FF","MOV R7,A (or byte 0FFh)",1,1
